<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible">
    <title>Document</title>

    <style>
        img {
            -webkit-user-select: none;
            -khtml-user-select: none;
            -moz-user-select: none;
            -o-user-select: none;
            user-select: none;
        }

        div {
            -webkit-user-select: none;
            -khtml-user-select: none;
            -moz-user-select: none;
            -o-user-select: none;
            user-select: none;
        }
    </style>
</head>

<body>
    <div id="image_container" onmousemove="continueMoving(event); continueResizing(event)"
        onmouseup="stopMoving(event); stopResizing(event)">
        <img id="image" draggable="false" style="width:auto; height: auto;">
        <canvas id="select_box1" width="200" height="100"
            style="border:1px solid red; position: absolute; top: 200; left: 50; cursor: grab; visibility: hidden;"
            onmousedown="startMoving(event, 'select_box1'); startResizing(event, 'select_box1')"
            onmousemove="determineCursor(event, 'select_box1')">
        </canvas>
        <canvas id="select_box2" width="200" height="100"
            style="border:1px solid green; position: absolute; top: 350; left: 50; cursor: grab; visibility: hidden;"
            onmousedown="startMoving(event, 'select_box2'); startResizing(event, 'select_box2')"
            onmousemove="determineCursor(event, 'select_box2')">
        </canvas>
        <canvas id="select_box3" width="260" height="40"
            style="border:1px solid magenta; position: absolute; top: 355; left: 1090; cursor: grab; visibility: hidden;"
            onmousedown="startMoving(event, 'select_box3'); startResizing(event, 'select_box3')"
            onmousemove="determineCursor(event, 'select_box3')">
        </canvas>
        <canvas id="select_box4" width="280" height="80"
            style="border:1px solid purple; position: absolute; top: 150; left: 1000; cursor: grab; visibility: hidden;"
            onmousedown="startMoving(event, 'select_box4'); startResizing(event, 'select_box4')"
            onmousemove="determineCursor(event, 'select_box4')">
        </canvas>
        <canvas id="move_box" width="200" height="100"
            style="border:1px dotted blue; position: absolute; cursor: grabbing; visibility: hidden;">
        </canvas>
    </div>
    <div>
        <input type="file" accept="image/*" onchange="loadFile(event);">
    </div>
    <br>
    <div>
        <button id="submit" style="visibility: hidden;" onclick="submit()">Submit</button>
    </div>
    <div>
        <label id="car_prediction_description" style="visibility: hidden;">Courtesy Amount Prediction:</label>
        <label id="car_prediction" style="visibility: hidden;"></label>
    </div>
    <div>
        <label id="car_confidence_description" style="visibility: hidden;">Courtesy Amount Prediction
            Confidence:</label>
        <label id="car_confidence" style="visibility: hidden;"></label>
    </div>
    <br>
    <div>
        <label id="lar_prediction_description" style="visibility: hidden;">Legal Amount Prediction:</label>
        <label id="lar_prediction" style="visibility: hidden;"></label>
    </div>
    <div>
        <label id="lar_confidence_description" style="visibility: hidden;">Legal Amount Prediction Confidence:</label>
        <label id="lar_confidence" style="visibility: hidden;"></label>
    </div>
    <br>
    <div>
        <label id="date_prediction_description" style="visibility: hidden;">Date Prediction:</label>
        <label id="date_prediction" style="visibility: hidden;"></label>
    </div>
    <div>
        <label id="date_confidence_description" style="visibility: hidden;">Date Prediction Confidence:</label>
        <label id="date_confidence" style="visibility: hidden;"></label>
    </div>

    <script>
        const CURSORS = {
            'W': 'ew-resize',
            'E': 'ew-resize',
            'N': 'ns-resize',
            'S': 'ns-resize',
            'NW': 'nw-resize',
            'NE': 'ne-resize',
            'SW': 'sw-resize',
            'SE': 'se-resize'
        }

        const RESIZING_LAMBDAS = {
            'W': [continueResizingW],
            'E': [continueResizingE],
            'N': [continueResizingN],
            'S': [continueResizingS],
            'NW': [continueResizingN, continueResizingW],
            'NE': [continueResizingN, continueResizingE],
            'SW': [continueResizingS, continueResizingW],
            'SE': [continueResizingS, continueResizingE],
        }

        const STOP_RESIZING_LAMBDAS = {
            'W': [stopResizingW],
            'E': [stopResizingE],
            'N': [stopResizingN],
            'S': [stopResizingS],
            'NW': [stopResizingN, stopResizingW],
            'NE': [stopResizingN, stopResizingE],
            'SW': [stopResizingS, stopResizingW],
            'SE': [stopResizingS, stopResizingE],
        }

        const RESIZE_MARGIN = 10;

        window.selectBox = null;
        window.isMoving = false;

        window.isResizing = {
            'W': false,
            'E': false,
            'N': false,
            'S': false,
            'NW': false,
            'NE': false,
            'SW': false,
            'SE': false
        };

        window.deltaX = 0;
        window.deltaY = 0;

        function loadFile(event) {
            var reader = new FileReader();
            reader.onload = function () {
                image = document.getElementById('image');
                image.src = reader.result;
                image.style.cursor = 'wait';
                imageContainer = document.getElementById('image_container');
                imageContainer.style.cursor = 'wait';

                var http = new XMLHttpRequest();
                var url = 'http://127.0.0.1:5000/get-boxes';
                http.open('POST', url, true);

                http.setRequestHeader('Content-type', 'application/text');

                http.onreadystatechange = function () {
                    if (http.readyState == 4 && http.status == 200) {
                        image = document.getElementById('image');
                        rectangles = JSON.parse(http.response);

                        y1 = rectangles['lar_line1'][0] + image.offsetTop;
                        y2 = rectangles['lar_line1'][1] + image.offsetTop;
                        x1 = rectangles['lar_line1'][2] + image.offsetLeft;
                        x2 = rectangles['lar_line1'][3] + image.offsetLeft;

                        if (isRectangleValid(x1, y1, x2, y2)) {
                            box = document.getElementById('select_box1');
                            box.style.top = y1;
                            box.style.left = x1;
                            box.width = x2 - x1;
                            box.height = y2 - y1;
                        }

                        y1 = rectangles['lar_line2'][0] + image.offsetTop;
                        y2 = rectangles['lar_line2'][1] + image.offsetTop;
                        x1 = rectangles['lar_line2'][2] + image.offsetLeft;
                        x2 = rectangles['lar_line2'][3] + image.offsetLeft;

                        if (isRectangleValid(x1, y1, x2, y2)) {
                            box = document.getElementById('select_box2');
                            box.style.top = y1;
                            box.style.left = x1;
                            box.width = x2 - x1;
                            box.height = y2 - y1;
                        }

                        y1 = rectangles['car_box'][0] + image.offsetTop;
                        y2 = rectangles['car_box'][1] + image.offsetTop;
                        x1 = rectangles['car_box'][2] + image.offsetLeft;
                        x2 = rectangles['car_box'][3] + image.offsetLeft;

                        if (isRectangleValid(x1, y1, x2, y2)) {
                            box = document.getElementById('select_box3');
                            box.style.top = y1;
                            box.style.left = x1;
                            box.width = x2 - x1;
                            box.height = y2 - y1;
                        }

                        viewRectangles();
                        image.style.cursor = 'default';
                        imageContainer.style.cursor = 'default';
                    }
                }
                http.send(reader.result.substring(22));
            };
            reader.readAsDataURL(event.target.files[0]);
        }

        function isRectangleValid(x1, y1, x2, y2) {
            if (x1 > 0 && y1 > 0 && x2 > 0 && y2 > 0 && x2 > x1 + 10 && y2 > y1 + 10) {
                return true;
            }
            return false;
        }

        function submit() {
            image = document.getElementById('image');

            box = document.getElementById('select_box1');
            y11 = parseInt(box.style.top) - image.offsetTop;
            y12 = parseInt(box.height) + parseInt(box.style.top) - image.offsetTop;
            x11 = parseInt(box.style.left) - image.offsetLeft;
            x12 = parseInt(box.width) + parseInt(box.style.left) - image.offsetLeft;

            box = document.getElementById('select_box2');
            y21 = parseInt(box.style.top) - image.offsetTop;
            y22 = parseInt(box.height) + parseInt(box.style.top) - image.offsetTop;
            x21 = parseInt(box.style.left) - image.offsetLeft;
            x22 = parseInt(box.width) + parseInt(box.style.left) - image.offsetLeft;

            box = document.getElementById('select_box3');
            car_y1 = parseInt(box.style.top) - image.offsetTop;
            car_y2 = parseInt(box.height) + parseInt(box.style.top) - image.offsetTop;
            car_x1 = parseInt(box.style.left) - image.offsetLeft;
            car_x2 = parseInt(box.width) + parseInt(box.style.left) - image.offsetLeft;

            box = document.getElementById('select_box4');
            date_y1 = parseInt(box.style.top) - image.offsetTop;
            date_y2 = parseInt(box.height) + parseInt(box.style.top) - image.offsetTop;
            date_x1 = parseInt(box.style.left) - image.offsetLeft;
            date_x2 = parseInt(box.width) + parseInt(box.style.left) - image.offsetLeft;

            var http = new XMLHttpRequest();
            var url = 'http://localhost:9000/recognize';
            http.open('POST', url, true);

            http.setRequestHeader('Content-Type', 'application/json');
            http.onreadystatechange = function () {
                if (http.readyState == 4 && http.status == 200) {
                    recognitions = JSON.parse(http.response);

                    document.getElementById('car_prediction_description').style.visibility = 'visible';
                    document.getElementById('car_confidence_description').style.visibility = 'visible';
                    document.getElementById('lar_prediction_description').style.visibility = 'visible';
                    document.getElementById('lar_confidence_description').style.visibility = 'visible';
                    document.getElementById('date_prediction_description').style.visibility = 'visible';
                    document.getElementById('date_confidence_description').style.visibility = 'visible';

                    carPrediction = document.getElementById('car_prediction');
                    carPrediction.style.visibility = 'visible';
                    carPrediction.innerText = parseFloat(recognitions['car_label']);

                    carConfidence = document.getElementById('car_confidence');
                    carConfidence.style.visibility = 'visible';
                    carConfidence.innerText = parseFloat(recognitions['car_confidence']) * 100;

                    larPrediction = document.getElementById('lar_prediction');
                    larPrediction.style.visibility = 'visible';
                    larPrediction.innerText = parseFloat(recognitions['lar_label']);

                    larConfidence = document.getElementById('lar_confidence');
                    larConfidence.style.visibility = 'visible';
                    larConfidence.innerText = parseFloat(recognitions['lar_confidence']) * 100;

                    datePrediction = document.getElementById('date_prediction');
                    datePrediction.style.visibility = 'visible';
                    datePrediction.innerText = recognitions['date_label'];

                    dateConfidence = document.getElementById('date_confidence');
                    dateConfidence.style.visibility = 'visible';
                    dateConfidence.innerText = parseFloat(recognitions['date_confidence']) * 100;
                }
            }
            http.send(JSON.stringify({
                "image": image.src.substring(22),
                "lar_line1": [x11, y11, x12, y12],
                "lar_line2": [x21, y21, x22, y22],
                "car_box": [car_x1, car_y1, car_x2, car_y2],
                "date_box": [date_x1, date_y1, date_x2, date_y2]
            }));
        }

        function viewRectangles() {
            document.getElementById('select_box1').style.visibility = 'visible';
            document.getElementById('select_box2').style.visibility = 'visible';
            document.getElementById('select_box3').style.visibility = 'visible';
            document.getElementById('select_box4').style.visibility = 'visible';
            document.getElementById('submit').style.visibility = 'visible';
        }

        function startMoving(event, id) {
            window.selectBox = document.getElementById(id);
            selectBoxTop = parseInt(window.selectBox.style.top);
            selectBoxLeft = parseInt(window.selectBox.style.left);

            if (event.pageX > selectBoxLeft + RESIZE_MARGIN
                && event.pageX < selectBoxLeft + parseInt(window.selectBox.width) - RESIZE_MARGIN
                && event.pageY > selectBoxTop + RESIZE_MARGIN
                && event.pageY < selectBoxTop + parseInt(window.selectBox.height) - RESIZE_MARGIN) {
                moveBox = document.getElementById('move_box');
                setMoveBoxDimensionsAndPosition();

                moveBox.style.cursor = 'grabbing';
                moveBox.style.visibility = 'visible';
                window.isMoving = true;
            }
        }

        function continueMoving(event) {
            if (window.isMoving) {
                moveBox = document.getElementById('move_box');
                moveBox.style.top = event.pageY - window.deltaY;
                moveBox.style.left = event.pageX - window.deltaX;
            }
        }

        function stopMoving(event) {
            if (window.isMoving) {
                moveBox = document.getElementById('move_box');
                moveBox.style.visibility = 'hidden';
                window.selectBox.style.top = event.pageY - window.deltaY;
                window.selectBox.style.left = event.pageX - window.deltaX;
                window.isMoving = false;
            }
        }

        function determineCursor(event, id) {
            window.selectBox = document.getElementById(id);

            selectBoxTop = parseInt(window.selectBox.style.top);
            selectBoxLeft = parseInt(window.selectBox.style.left);
            selectBoxWidth = parseInt(window.selectBox.width);
            selectBoxHeight = parseInt(window.selectBox.height);

            if (event.pageX > selectBoxLeft + RESIZE_MARGIN && event.pageX < selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY > selectBoxTop + RESIZE_MARGIN && event.pageY < selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                window.selectBox.style.cursor = 'grab';
            }

            directionCode = getDirectionCode(event, window.selectBox);
            if (directionCode != null) {
                window.selectBox.style.cursor = CURSORS[directionCode];
            }
        }

        function startResizing(event, id) {
            window.selectBox = document.getElementById(id);

            moveBox = document.getElementById('move_box');
            imageContainer = document.getElementById('image_container');

            directionCode = getDirectionCode(event, window.selectBox);
            if (directionCode != null) {
                viewMoveBoxAndDetermineCursors(directionCode, moveBox, imageContainer);
            }
        }

        function continueResizing(event) {
            moveBox = document.getElementById('move_box');

            Object.keys(window.isResizing).filter(c => window.isResizing[c]).forEach(c => {
                RESIZING_LAMBDAS[c].forEach(lambda => lambda(event, window.selectBox, moveBox));
            });
        }

        function stopResizing(event) {
            moveBox = document.getElementById('move_box');
            imageContainer = document.getElementById('image_container');

            Object.keys(window.isResizing).filter(c => window.isResizing[c]).forEach(c => {
                STOP_RESIZING_LAMBDAS[c].forEach(lambda => lambda(event, window.selectBox, moveBox, imageContainer));
                window.isResizing[c] = false;
                hideMoveBoxAndResetCursor(moveBox, imageContainer);
            });
        }

        function getDirectionCode(event, selectBox) {
            selectBoxTop = parseInt(selectBox.style.top);
            selectBoxLeft = parseInt(selectBox.style.left);
            selectBoxWidth = parseInt(selectBox.width);
            selectBoxHeight = parseInt(selectBox.height);

            if (event.pageX <= selectBoxLeft + RESIZE_MARGIN
                && event.pageY > selectBoxTop + RESIZE_MARGIN
                && event.pageY < selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                return 'W';
            }

            if (event.pageX >= selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY > selectBoxTop + RESIZE_MARGIN
                && event.pageY < selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                return 'E';
            }

            if (event.pageX > selectBoxLeft + RESIZE_MARGIN
                && event.pageX < selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY <= selectBoxTop + RESIZE_MARGIN) {
                return 'N';
            }

            if (event.pageX > selectBoxLeft + RESIZE_MARGIN
                && event.pageX < selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY >= selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                return 'S';
            }

            if (event.pageX <= selectBoxLeft + RESIZE_MARGIN
                && event.pageY <= selectBoxTop + RESIZE_MARGIN) {
                return 'NW';
            }

            if (event.pageX >= selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY <= selectBoxTop + RESIZE_MARGIN) {
                return 'NE';
            }

            if (event.pageX <= selectBoxLeft + RESIZE_MARGIN
                && event.pageY >= selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                return 'SW';
            }

            if (event.pageX >= selectBoxLeft + selectBoxWidth - RESIZE_MARGIN
                && event.pageY >= selectBoxTop + selectBoxHeight - RESIZE_MARGIN) {
                return 'SE';
            }

            return null;
        }

        function viewMoveBoxAndDetermineCursors(direction, moveBox, imageContainer) {
            setMoveBoxDimensionsAndPosition();

            moveBox.style.cursor = CURSORS[direction];
            moveBox.style.visibility = 'visible';
            window.isResizing[direction] = true;

            imageContainer.style.cursor = CURSORS[direction];
        }

        function setMoveBoxDimensionsAndPosition() {
            selectBoxTop = parseInt(window.selectBox.style.top);
            selectBoxLeft = parseInt(window.selectBox.style.left);

            moveBox = document.getElementById('move_box');
            moveBox.width = selectBox.width;
            moveBox.height = selectBox.height;

            window.deltaY = event.pageY - selectBoxTop;
            window.deltaX = event.pageX - selectBoxLeft;

            moveBox.style.top = selectBoxTop;
            moveBox.style.left = selectBoxLeft;
        }

        function continueResizingW(event, selectBox, moveBox) {
            moveBox.style.left = event.pageX - window.deltaX;
            moveBox.width = parseInt(selectBox.width) + parseInt(selectBox.style.left) - parseInt(moveBox.style.left);
        }

        function continueResizingE(event, selectBox, moveBox) {
            moveBox.width = event.pageX + window.deltaX - (parseInt(selectBox.style.left) + parseInt(selectBox.width));
        }

        function continueResizingN(event, selectBox, moveBox) {
            moveBox.style.top = event.pageY - window.deltaY;
            moveBox.height = parseInt(selectBox.height) + parseInt(selectBox.style.top) - parseInt(moveBox.style.top);
        }

        function continueResizingS(event, selectBox, moveBox) {
            moveBox.height = event.pageY + window.deltaY - (parseInt(selectBox.style.top) + parseInt(selectBox.height));
        }

        function stopResizingW(event, selectBox, moveBox, imageContainer) {
            moveBox.style.left = event.pageX - window.deltaX;
            moveBox.width = parseInt(selectBox.width) + parseInt(selectBox.style.left) - parseInt(moveBox.style.left);
            selectBox.style.left = moveBox.style.left;
            selectBox.width = moveBox.width;
        }

        function stopResizingE(event, selectBox, moveBox, imageContainer) {
            moveBox.width = event.pageX + window.deltaX - (parseInt(selectBox.style.left) + parseInt(selectBox.width));
            selectBox.width = moveBox.width;
        }

        function stopResizingN(event, selectBox, moveBox, imageContainer) {
            moveBox.style.top = event.pageY - window.deltaY;
            moveBox.height = parseInt(selectBox.height) + parseInt(selectBox.style.top) - parseInt(moveBox.style.top);
            selectBox.style.top = moveBox.style.top;
            selectBox.height = moveBox.height;
        }

        function stopResizingS(event, selectBox, moveBox, imageContainer) {
            moveBox.height = event.pageY + window.deltaY - (parseInt(selectBox.style.top) + parseInt(selectBox.height));
            selectBox.height = moveBox.height;
        }

        function hideMoveBoxAndResetCursor(moveBox, imageContainer) {
            moveBox.style.visibility = 'hidden';
            imageContainer.style.cursor = 'default';
        }
    </script>
</body>

</html>